package com.onehippo.cms;

import org.hippoecm.repository.api.StringCodec;
import org.hippoecm.repository.api.StringCodecFactory;

public abstract class BaseCodec implements StringCodec {

    private StringCodec uriEncoder = new StringCodecFactory.UriEncoding();

    @Override
    public String encode(final String plain) {
        return getPrefix() + uriEncoder.encode(decode(plain));
    }

    @Override
    public String decode(final String encoded) {
        if (encoded.startsWith(getPrefix())) {
            return encoded.substring(getPrefix().length());
        }
        return encoded;
    }
    
    protected abstract String getPrefix();
}
